diff --git a/include/odp/api/spec/align.h b/include/odp/api/spec/align.h
index fdf8c29e14e4..0a9db3488232 100644
--- a/include/odp/api/spec/align.h
+++ b/include/odp/api/spec/align.h
@@ -11,8 +11,8 @@
  * ODP alignments
  */
 
-#ifndef ODP_API_ALIGN_H_
-#define ODP_API_ALIGN_H_
+#ifndef ODP_API_SPEC_ALIGN_H_
+#define ODP_API_SPEC_ALIGN_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/atomic.h b/include/odp/api/spec/atomic.h
index 408829df299f..d828ea47da3b 100644
--- a/include/odp/api/spec/atomic.h
+++ b/include/odp/api/spec/atomic.h
@@ -10,8 +10,8 @@
  * ODP atomic operations
  */
 
-#ifndef ODP_API_ATOMIC_H_
-#define ODP_API_ATOMIC_H_
+#ifndef ODP_API_SPEC_ATOMIC_H_
+#define ODP_API_SPEC_ATOMIC_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/barrier.h b/include/odp/api/spec/barrier.h
index 6de683c73e0c..8351ef8864b7 100644
--- a/include/odp/api/spec/barrier.h
+++ b/include/odp/api/spec/barrier.h
@@ -10,8 +10,8 @@
  * ODP execution barriers
  */
 
-#ifndef ODP_API_BARRIER_H_
-#define ODP_API_BARRIER_H_
+#ifndef ODP_API_SPEC_BARRIER_H_
+#define ODP_API_SPEC_BARRIER_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/buffer.h b/include/odp/api/spec/buffer.h
index 94829b324dd9..b2f90f949864 100644
--- a/include/odp/api/spec/buffer.h
+++ b/include/odp/api/spec/buffer.h
@@ -11,8 +11,8 @@
  * ODP buffer descriptor
  */
 
-#ifndef ODP_API_BUFFER_H_
-#define ODP_API_BUFFER_H_
+#ifndef ODP_API_SPEC_BUFFER_H_
+#define ODP_API_SPEC_BUFFER_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/byteorder.h b/include/odp/api/spec/byteorder.h
index 38c0bdbf7a3d..814438d3f803 100644
--- a/include/odp/api/spec/byteorder.h
+++ b/include/odp/api/spec/byteorder.h
@@ -10,8 +10,8 @@
  * ODP byteorder
  */
 
-#ifndef ODP_API_BYTEORDER_H_
-#define ODP_API_BYTEORDER_H_
+#ifndef ODP_API_SPEC_BYTEORDER_H_
+#define ODP_API_SPEC_BYTEORDER_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/chksum.h b/include/odp/api/spec/chksum.h
index e523ac286528..8f35e253fe91 100644
--- a/include/odp/api/spec/chksum.h
+++ b/include/odp/api/spec/chksum.h
@@ -10,8 +10,8 @@
  * ODP Hash functions
  */
 
-#ifndef ODP_API_CHKSUM_H_
-#define ODP_API_CHKSUM_H_
+#ifndef ODP_API_SPEC_CHKSUM_H_
+#define ODP_API_SPEC_CHKSUM_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/classification.h b/include/odp/api/spec/classification.h
index d0d51d1fb2b8..d395feae2102 100644
--- a/include/odp/api/spec/classification.h
+++ b/include/odp/api/spec/classification.h
@@ -10,8 +10,8 @@
  * ODP classification descriptor
  */
 
-#ifndef ODP_API_CLASSIFY_H_
-#define ODP_API_CLASSIFY_H_
+#ifndef ODP_API_SPEC_CLASSIFY_H_
+#define ODP_API_SPEC_CLASSIFY_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/compiler.h b/include/odp/api/spec/compiler.h
index c88350e2c17e..443607fbd22c 100644
--- a/include/odp/api/spec/compiler.h
+++ b/include/odp/api/spec/compiler.h
@@ -11,8 +11,8 @@
  * Compiler related
  */
 
-#ifndef ODP_API_COMPILER_H_
-#define ODP_API_COMPILER_H_
+#ifndef ODP_API_SPEC_COMPILER_H_
+#define ODP_API_SPEC_COMPILER_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/cpu.h b/include/odp/api/spec/cpu.h
index 0f47e4798116..04fbbe9006d2 100644
--- a/include/odp/api/spec/cpu.h
+++ b/include/odp/api/spec/cpu.h
@@ -11,8 +11,8 @@
  * ODP CPU API
  */
 
-#ifndef ODP_CPU_H_
-#define ODP_CPU_H_
+#ifndef ODP_API_SPEC_CPU_H_
+#define ODP_API_SPEC_CPU_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/cpumask.h b/include/odp/api/spec/cpumask.h
index 22d8e8f246f0..68a705d25262 100644
--- a/include/odp/api/spec/cpumask.h
+++ b/include/odp/api/spec/cpumask.h
@@ -11,8 +11,8 @@
  * ODP CPU masks and enumeration
  */
 
-#ifndef ODP_API_CPUMASK_H_
-#define ODP_API_CPUMASK_H_
+#ifndef ODP_API_SPEC_CPUMASK_H_
+#define ODP_API_SPEC_CPUMASK_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/crypto.h b/include/odp/api/spec/crypto.h
index 7dcb71264f8a..7720468ee0ce 100644
--- a/include/odp/api/spec/crypto.h
+++ b/include/odp/api/spec/crypto.h
@@ -11,8 +11,8 @@
  * ODP crypto
  */
 
-#ifndef ODP_API_CRYPTO_H_
-#define ODP_API_CRYPTO_H_
+#ifndef ODP_API_SPEC_CRYPTO_H_
+#define ODP_API_SPEC_CRYPTO_H_
 #include <odp/visibility_begin.h>
 
 #include <odp/api/deprecated.h>
diff --git a/include/odp/api/spec/debug.h b/include/odp/api/spec/debug.h
index b3b170f3e386..c2896a824b51 100644
--- a/include/odp/api/spec/debug.h
+++ b/include/odp/api/spec/debug.h
@@ -9,8 +9,8 @@
  * ODP debug
  */
 
-#ifndef ODP_API_DEBUG_H_
-#define ODP_API_DEBUG_H_
+#ifndef ODP_API_SPEC_DEBUG_H_
+#define ODP_API_SPEC_DEBUG_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/deprecated.h.in b/include/odp/api/spec/deprecated.h.in
index 224f60ff37ab..25520b9d8e21 100644
--- a/include/odp/api/spec/deprecated.h.in
+++ b/include/odp/api/spec/deprecated.h.in
@@ -10,8 +10,8 @@
  * Macro for deprecated API definitions
  */
 
-#ifndef ODP_API_DEPRECATED_H_
-#define ODP_API_DEPRECATED_H_
+#ifndef ODP_API_SPEC_DEPRECATED_H_
+#define ODP_API_SPEC_DEPRECATED_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/errno.h b/include/odp/api/spec/errno.h
index 9b60a98bafe2..ca74f7416a06 100644
--- a/include/odp/api/spec/errno.h
+++ b/include/odp/api/spec/errno.h
@@ -10,8 +10,8 @@
  * ODP errno API
  */
 
-#ifndef ODP_ERRNO_H_
-#define ODP_ERRNO_H_
+#ifndef ODP_API_SPEC_ERRNO_H_
+#define ODP_API_SPEC_ERRNO_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/event.h b/include/odp/api/spec/event.h
index f924973f0f91..0638f674ed37 100644
--- a/include/odp/api/spec/event.h
+++ b/include/odp/api/spec/event.h
@@ -11,8 +11,8 @@
  * ODP event
  */
 
-#ifndef ODP_API_EVENT_H_
-#define ODP_API_EVENT_H_
+#ifndef ODP_API_SPEC_EVENT_H_
+#define ODP_API_SPEC_EVENT_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/feature.h b/include/odp/api/spec/feature.h
index 0cfc141db906..b64b2c7d0fd8 100644
--- a/include/odp/api/spec/feature.h
+++ b/include/odp/api/spec/feature.h
@@ -12,8 +12,8 @@
  * components.
  */
 
-#ifndef ODP_API_FEATURE_H_
-#define ODP_API_FEATURE_H_
+#ifndef ODP_API_SPEC_FEATURE_H_
+#define ODP_API_SPEC_FEATURE_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/hash.h b/include/odp/api/spec/hash.h
index 66b740e2c133..e86b2c6d7ee0 100644
--- a/include/odp/api/spec/hash.h
+++ b/include/odp/api/spec/hash.h
@@ -10,8 +10,8 @@
  * ODP Hash functions
  */
 
-#ifndef ODP_API_HASH_H_
-#define ODP_API_HASH_H_
+#ifndef ODP_API_SPEC_HASH_H_
+#define ODP_API_SPEC_HASH_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/hints.h b/include/odp/api/spec/hints.h
index 7434c6a5c328..649957374cdb 100644
--- a/include/odp/api/spec/hints.h
+++ b/include/odp/api/spec/hints.h
@@ -11,8 +11,8 @@
  * ODP compiler hints
  */
 
-#ifndef ODP_API_HINTS_H_
-#define ODP_API_HINTS_H_
+#ifndef ODP_API_SPEC_HINTS_H_
+#define ODP_API_SPEC_HINTS_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/init.h b/include/odp/api/spec/init.h
index e8ec41136c3b..56c86740f9bc 100644
--- a/include/odp/api/spec/init.h
+++ b/include/odp/api/spec/init.h
@@ -19,8 +19,8 @@
  * - odp_term_local()
  */
 
-#ifndef ODP_API_INIT_H_
-#define ODP_API_INIT_H_
+#ifndef ODP_API_SPEC_INIT_H_
+#define ODP_API_SPEC_INIT_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/ipsec.h b/include/odp/api/spec/ipsec.h
index 26e852fca1d7..441c35c16454 100644
--- a/include/odp/api/spec/ipsec.h
+++ b/include/odp/api/spec/ipsec.h
@@ -10,8 +10,8 @@
  * ODP IPSEC API
  */
 
-#ifndef ODP_API_IPSEC_H_
-#define ODP_API_IPSEC_H_
+#ifndef ODP_API_SPEC_IPSEC_H_
+#define ODP_API_SPEC_IPSEC_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/packet.h b/include/odp/api/spec/packet.h
index 62ecf70e1d0e..b665855529b4 100644
--- a/include/odp/api/spec/packet.h
+++ b/include/odp/api/spec/packet.h
@@ -11,8 +11,8 @@
  * ODP packet descriptor
  */
 
-#ifndef ODP_API_PACKET_H_
-#define ODP_API_PACKET_H_
+#ifndef ODP_API_SPEC_PACKET_H_
+#define ODP_API_SPEC_PACKET_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/packet_flags.h b/include/odp/api/spec/packet_flags.h
index 377b75ba0a55..8e86e5b58626 100644
--- a/include/odp/api/spec/packet_flags.h
+++ b/include/odp/api/spec/packet_flags.h
@@ -11,8 +11,8 @@
  * ODP packet flags
  */
 
-#ifndef ODP_API_PACKET_FLAGS_H_
-#define ODP_API_PACKET_FLAGS_H_
+#ifndef ODP_API_SPEC_PACKET_FLAGS_H_
+#define ODP_API_SPEC_PACKET_FLAGS_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/packet_io.h b/include/odp/api/spec/packet_io.h
index 52af646a6180..4156d07860f2 100644
--- a/include/odp/api/spec/packet_io.h
+++ b/include/odp/api/spec/packet_io.h
@@ -11,8 +11,8 @@
  * ODP Packet IO
  */
 
-#ifndef ODP_API_PACKET_IO_H_
-#define ODP_API_PACKET_IO_H_
+#ifndef ODP_API_SPEC_PACKET_IO_H_
+#define ODP_API_SPEC_PACKET_IO_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/packet_io_stats.h b/include/odp/api/spec/packet_io_stats.h
index 299ecd0e1d2a..18619143d525 100644
--- a/include/odp/api/spec/packet_io_stats.h
+++ b/include/odp/api/spec/packet_io_stats.h
@@ -10,8 +10,8 @@
  * ODP Packet IO
  */
 
-#ifndef ODP_API_PACKET_IO_STATS_H_
-#define ODP_API_PACKET_IO_STATS_H_
+#ifndef ODP_API_SPEC_PACKET_IO_STATS_H_
+#define ODP_API_SPEC_PACKET_IO_STATS_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/pool.h b/include/odp/api/spec/pool.h
index 221798ee8cc6..b537589b8d85 100644
--- a/include/odp/api/spec/pool.h
+++ b/include/odp/api/spec/pool.h
@@ -11,8 +11,8 @@
  * ODP pool
  */
 
-#ifndef ODP_API_POOL_H_
-#define ODP_API_POOL_H_
+#ifndef ODP_API_SPEC_POOL_H_
+#define ODP_API_SPEC_POOL_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/queue.h b/include/odp/api/spec/queue.h
index 3cd99a9f3035..b82c1b852fb1 100644
--- a/include/odp/api/spec/queue.h
+++ b/include/odp/api/spec/queue.h
@@ -11,8 +11,8 @@
  * ODP queue
  */
 
-#ifndef ODP_API_QUEUE_H_
-#define ODP_API_QUEUE_H_
+#ifndef ODP_API_SPEC_QUEUE_H_
+#define ODP_API_SPEC_QUEUE_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/random.h b/include/odp/api/spec/random.h
index 4765475c24c5..8bed969b6ad8 100644
--- a/include/odp/api/spec/random.h
+++ b/include/odp/api/spec/random.h
@@ -11,8 +11,8 @@
  * ODP random number API
  */
 
-#ifndef ODP_API_RANDOM_H_
-#define ODP_API_RANDOM_H_
+#ifndef ODP_API_SPEC_RANDOM_H_
+#define ODP_API_SPEC_RANDOM_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/rwlock.h b/include/odp/api/spec/rwlock.h
index ff8a3f2783d1..3e5c47ba62fc 100644
--- a/include/odp/api/spec/rwlock.h
+++ b/include/odp/api/spec/rwlock.h
@@ -4,8 +4,8 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
-#ifndef ODP_API_RWLOCK_H_
-#define ODP_API_RWLOCK_H_
+#ifndef ODP_API_SPEC_RWLOCK_H_
+#define ODP_API_SPEC_RWLOCK_H_
 #include <odp/visibility_begin.h>
 
 /**
diff --git a/include/odp/api/spec/rwlock_recursive.h b/include/odp/api/spec/rwlock_recursive.h
index 1c19c7217d08..03a4dce4e83c 100644
--- a/include/odp/api/spec/rwlock_recursive.h
+++ b/include/odp/api/spec/rwlock_recursive.h
@@ -10,8 +10,8 @@
  * ODP recursive read/write lock
  */
 
-#ifndef ODP_API_RWLOCK_RECURSIVE_H_
-#define ODP_API_RWLOCK_RECURSIVE_H_
+#ifndef ODP_API_SPEC_RWLOCK_RECURSIVE_H_
+#define ODP_API_SPEC_RWLOCK_RECURSIVE_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/schedule.h b/include/odp/api/spec/schedule.h
index fe2300db0f0b..524449647b0c 100644
--- a/include/odp/api/spec/schedule.h
+++ b/include/odp/api/spec/schedule.h
@@ -11,8 +11,8 @@
  * ODP schedule
  */
 
-#ifndef ODP_API_SCHEDULE_H_
-#define ODP_API_SCHEDULE_H_
+#ifndef ODP_API_SPEC_SCHEDULE_H_
+#define ODP_API_SPEC_SCHEDULE_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/schedule_types.h b/include/odp/api/spec/schedule_types.h
index 397f98fcd452..e0dc4027b91b 100644
--- a/include/odp/api/spec/schedule_types.h
+++ b/include/odp/api/spec/schedule_types.h
@@ -10,8 +10,8 @@
  * ODP schedule types
  */
 
-#ifndef ODP_API_SCHEDULE_TYPES_H_
-#define ODP_API_SCHEDULE_TYPES_H_
+#ifndef ODP_API_SPEC_SCHEDULE_TYPES_H_
+#define ODP_API_SPEC_SCHEDULE_TYPES_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/shared_memory.h b/include/odp/api/spec/shared_memory.h
index 1a9c1299e5da..1b534d927fc3 100644
--- a/include/odp/api/spec/shared_memory.h
+++ b/include/odp/api/spec/shared_memory.h
@@ -11,8 +11,8 @@
  * ODP shared memory
  */
 
-#ifndef ODP_API_SHARED_MEMORY_H_
-#define ODP_API_SHARED_MEMORY_H_
+#ifndef ODP_API_SPEC_SHARED_MEMORY_H_
+#define ODP_API_SPEC_SHARED_MEMORY_H_
 #include <odp/visibility_begin.h>
 #include <odp/api/init.h>
 
diff --git a/include/odp/api/spec/spinlock.h b/include/odp/api/spec/spinlock.h
index 11b7339b101f..fc7629dda76a 100644
--- a/include/odp/api/spec/spinlock.h
+++ b/include/odp/api/spec/spinlock.h
@@ -10,8 +10,8 @@
  * ODP spinlock
  */
 
-#ifndef ODP_API_SPINLOCK_H_
-#define ODP_API_SPINLOCK_H_
+#ifndef ODP_API_SPEC_SPINLOCK_H_
+#define ODP_API_SPEC_SPINLOCK_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/spinlock_recursive.h b/include/odp/api/spec/spinlock_recursive.h
index c9c7ddb02fd7..7546e75eae19 100644
--- a/include/odp/api/spec/spinlock_recursive.h
+++ b/include/odp/api/spec/spinlock_recursive.h
@@ -10,8 +10,8 @@
  * ODP recursive spinlock
  */
 
-#ifndef ODP_API_SPINLOCK_RECURSIVE_H_
-#define ODP_API_SPINLOCK_RECURSIVE_H_
+#ifndef ODP_API_SPEC_SPINLOCK_RECURSIVE_H_
+#define ODP_API_SPEC_SPINLOCK_RECURSIVE_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/std_clib.h b/include/odp/api/spec/std_clib.h
index 33e9db5361fb..d308442051bc 100644
--- a/include/odp/api/spec/std_clib.h
+++ b/include/odp/api/spec/std_clib.h
@@ -10,8 +10,8 @@
  * ODP version of often used C library calls
  */
 
-#ifndef ODP_API_STD_CLIB_H_
-#define ODP_API_STD_CLIB_H_
+#ifndef ODP_API_SPEC_STD_CLIB_H_
+#define ODP_API_SPEC_STD_CLIB_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/std_types.h b/include/odp/api/spec/std_types.h
index ec6a6df6d75d..4732b6fe4d91 100644
--- a/include/odp/api/spec/std_types.h
+++ b/include/odp/api/spec/std_types.h
@@ -12,8 +12,8 @@
  *
  */
 
-#ifndef ODP_API_STD_TYPES_H_
-#define ODP_API_STD_TYPES_H_
+#ifndef ODP_API_SPEC_STD_TYPES_H_
+#define ODP_API_SPEC_STD_TYPES_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/support.h b/include/odp/api/spec/support.h
index cc43b6f0e2bc..df732d1815d9 100644
--- a/include/odp/api/spec/support.h
+++ b/include/odp/api/spec/support.h
@@ -10,8 +10,8 @@
  * ODP support API
  */
 
-#ifndef ODP_API_SUPPORT_H_
-#define ODP_API_SUPPORT_H_
+#ifndef ODP_API_SPEC_SUPPORT_H_
+#define ODP_API_SPEC_SUPPORT_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/sync.h b/include/odp/api/spec/sync.h
index 6f87db559367..1306687c045b 100644
--- a/include/odp/api/spec/sync.h
+++ b/include/odp/api/spec/sync.h
@@ -10,8 +10,8 @@
  * ODP memory barriers
  */
 
-#ifndef ODP_API_SYNC_H_
-#define ODP_API_SYNC_H_
+#ifndef ODP_API_SPEC_SYNC_H_
+#define ODP_API_SPEC_SYNC_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/system_info.h b/include/odp/api/spec/system_info.h
index 140db7b4fd17..38767640faac 100644
--- a/include/odp/api/spec/system_info.h
+++ b/include/odp/api/spec/system_info.h
@@ -11,8 +11,8 @@
  * ODP system information
  */
 
-#ifndef ODP_API_SYSTEM_INFO_H_
-#define ODP_API_SYSTEM_INFO_H_
+#ifndef ODP_API_SPEC_SYSTEM_INFO_H_
+#define ODP_API_SPEC_SYSTEM_INFO_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/thread.h b/include/odp/api/spec/thread.h
index 689ba59b58fa..5fe74c69da87 100644
--- a/include/odp/api/spec/thread.h
+++ b/include/odp/api/spec/thread.h
@@ -11,8 +11,8 @@
  * ODP thread API
  */
 
-#ifndef ODP_API_THREAD_H_
-#define ODP_API_THREAD_H_
+#ifndef ODP_API_SPEC_THREAD_H_
+#define ODP_API_SPEC_THREAD_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/thrmask.h b/include/odp/api/spec/thrmask.h
index 3986769acedb..cd37e6149580 100644
--- a/include/odp/api/spec/thrmask.h
+++ b/include/odp/api/spec/thrmask.h
@@ -10,8 +10,8 @@
  * ODP thread masks
  */
 
-#ifndef ODP_API_THRMASK_H_
-#define ODP_API_THRMASK_H_
+#ifndef ODP_API_SPEC_THRMASK_H_
+#define ODP_API_SPEC_THRMASK_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/ticketlock.h b/include/odp/api/spec/ticketlock.h
index b23253b5536c..bf706cb39724 100644
--- a/include/odp/api/spec/ticketlock.h
+++ b/include/odp/api/spec/ticketlock.h
@@ -11,8 +11,8 @@
  * ODP ticketlock
  */
 
-#ifndef ODP_API_TICKETLOCK_H_
-#define ODP_API_TICKETLOCK_H_
+#ifndef ODP_API_SPEC_TICKETLOCK_H_
+#define ODP_API_SPEC_TICKETLOCK_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/time.h b/include/odp/api/spec/time.h
index 29175eb5a60e..dec1b9a7b556 100644
--- a/include/odp/api/spec/time.h
+++ b/include/odp/api/spec/time.h
@@ -11,8 +11,8 @@
  * ODP time
  */
 
-#ifndef ODP_API_TIME_H_
-#define ODP_API_TIME_H_
+#ifndef ODP_API_SPEC_TIME_H_
+#define ODP_API_SPEC_TIME_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/timer.h b/include/odp/api/spec/timer.h
index 17daafc78e1b..a85edda55fee 100644
--- a/include/odp/api/spec/timer.h
+++ b/include/odp/api/spec/timer.h
@@ -11,8 +11,8 @@
  * ODP timer service
  */
 
-#ifndef ODP_API_TIMER_H_
-#define ODP_API_TIMER_H_
+#ifndef ODP_API_SPEC_TIMER_H_
+#define ODP_API_SPEC_TIMER_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/traffic_mngr.h b/include/odp/api/spec/traffic_mngr.h
index c9134e8e4ff6..361e73653e66 100644
--- a/include/odp/api/spec/traffic_mngr.h
+++ b/include/odp/api/spec/traffic_mngr.h
@@ -4,8 +4,8 @@
  * SPDX-License-Identifier: BSD-3-Clause
  */
 
-#ifndef ODP_TRAFFIC_MNGR_H_
-#define ODP_TRAFFIC_MNGR_H_
+#ifndef ODP_API_SPEC_TRAFFIC_MNGR_H_
+#define ODP_API_SPEC_TRAFFIC_MNGR_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus
diff --git a/include/odp/api/spec/version.h.in b/include/odp/api/spec/version.h.in
index f5e9e9c8be91..1a9a83f9a970 100644
--- a/include/odp/api/spec/version.h.in
+++ b/include/odp/api/spec/version.h.in
@@ -11,8 +11,8 @@
  * ODP version
  */
 
-#ifndef ODP_API_VERSION_H_
-#define ODP_API_VERSION_H_
+#ifndef ODP_API_SPEC_VERSION_H_
+#define ODP_API_SPEC_VERSION_H_
 #include <odp/visibility_begin.h>
 
 #ifdef __cplusplus